<template>
  <div>
    <b-alert
      v-model="showOkAlert"
      variant="info"
      class="text-center"
    >
      Contraseña cambiada,
      <router-link :to="{name: 'login'}">
        ahora puedes hacer Login
      </router-link>
    </b-alert>
    <b-alert
      v-model="showDangerAlert"
      variant="danger"
      class="text-center"
    >
      Ha ocurrido un problema cambiando la contraseña. Prueba más tarde.
    </b-alert>

    <b-form class="mb-8" @submit.prevent="setNewPassword" v-if="!done">
      <b-form-group
        id="grop_password"
        label="Nueva contraseña"
        label-for="input_password"
        :state="form_state.new_password"
        :invalid-feedback="form_invalid_feedback.new_password"
      >
        <b-form-input
          id="input_password"
          type="password"
          :state="form_state.new_password"
          v-model="form.new_password"
        >
        </b-form-input>
      </b-form-group>

      <button class="btn btn-block btn-primary lift" type="submit">
        Cambiar contraseña
      </button>
      <p class="mt-5 text-center">
        Volver al
        <span>
          <router-link :to="{name: 'login'}">
            Login
          </router-link>
        </span>
      </p>
    </b-form>
  </div>
</template>

<script>
import { mapActions } from "vuex";
export default {
  name: "recover-pass-form-new-set",
  data() {
    return {
      form: { new_password: null },
      done: false,
      showOkAlert: false,
      showDangerAlert: false
    };
  },
  computed: {
    token() {
      return this.$route.params.token;
    },
    uid() {
      return this.$route.params.uid;
    }
  },
  created() {},
  methods: {
    ...mapActions({
      RESET_PASSWORD_CONFIRM: "auth/RESET_PASSWORD_CONFIRM"
    }),
    setNewPassword() {
      this.RESET_PASSWORD_CONFIRM({
        uid: this.uid,
        token: this.token,
        new_password: this.form.new_password
      }).then(
        () => {
          this.showOkAlert = true;
          this.showDangerAlert = false;
        },
        res => {
          if (!this.$putErrFeedback(res)) {
            this.showOkAlert = false;
            this.showDangerAlert = true;
          }
        }
      );
    }
  }
};
</script>

<style lang="scss" scoped>
form {
  max-width: 600px;
  margin: 0 auto;
}
</style>
